/*
 * ConstraintChecker.java
 *
 * Created on 24. januar 2006, 14:59
 */

package jcreek.gui.representation.constraints;

import jcreek.representation.*;
import jcreek.representation.constraints.*;

/**
 *
 * @author  Martin Stige
 */
public class ConstraintChecker {
    
    /** Creates a new instance of ConstraintChecker */
    public ConstraintChecker() {
    }
    
    public String check(KnowledgeModel km){
        String ret = "";
        Constraint[] c;
        Entity[] e = km.getEntities();
        
        int violations = 0;
        
        for(int j = 0; j < e.length; j++){
            //System.out.println(e[j].getName());
            c = e[j].getConstraints();
            
            for(int i = 0; i < c.length; i++){
                
                ConstraintCheckResult ccr = c[i].check(e[j]);
                if(ccr.isViolated()){
                    violations++;
                    ret += violations + " ---\n";
                    ret += c[i].toString() + "\n";
                    ret += ccr.getDescription() + "\n";
                }
            }
        }
        
        if(violations == 0)
            ret = "No constraints violated";
        else
            ret = violations + " constraints violated \n\n" + ret;
        
        return ret;
    }
    
    public String check(Entity e){
        String ret = "";
        Constraint[] c = e.getConstraints();
        int violations = 0;
        try{
            for(int i = 0; i < c.length; i++){
                ConstraintCheckResult ccr = c[i].check(e);
                                
                if(ccr.isViolated()){
                    violations++;
                    ret += violations + " ---\n";
                    ret += c[i].toString() + "\n";
                    ret += ccr.getDescription() + "\n";
                }
            }
            
            if(violations == 0)
                ret = "No constraints violated";
            else
                ret = violations + " constraints violated \n" + ret;
            
        }catch(Exception ex){
            System.out.println("Constraints " + c);
            System.out.println("#Constraint " + c.length);
            for(int i = 0; i < c.length;i++){
                System.out.println(c[i]);
            }
            System.out.println("------------");
            System.out.println("Entity " + e);
            System.out.println("------------");
            ex.printStackTrace();
        }
        
        return ret;
        
    }
}
