/*
 * FrameConstraints.java
 *
 * Created on 13. januar 2006, 14:28
 */

package jcreek.gui.representation.constraints;

import java.awt.Dimension;
import javax.swing.*;
import jcreek.representation.*;
import jcreek.representation.constraints.*;
import java.awt.BorderLayout;
/**
 *
 * @author  Martin Stige
 */
public class pnlFrameConstraints extends javax.swing.JPanel {
    protected Entity myEntity;
    private ListModel localConstraintListModel;
    private ListModel inheritedConstraintListModel;
    
    /**
     * Sets the entity that the Constraint Frame shall show
     * @param e the entity to be shown
     */
    public void setEntity(Entity e){
        myEntity = e;
        initMyComponents();
        pnlConstraintLine.setEntity(myEntity);
        splitConstraints.setDividerLocation((int)(splitConstraints.getHeight()*0.5));
        
    }
    
    /** Creates new form FrameConstraints */
    public pnlFrameConstraints() {
        initComponents();
        //    initMyComponents();
    }
    
    /**
     * Initiates the frame
     */
    private void initMyComponents(){
        if(myEntity == null)
            return;
        
        localConstraintListModel = new AbstractListModel() {
            public int getSize() { return myEntity.getLocalConstraints().length; }
            public Object getElementAt(int index) { return myEntity.getLocalConstraints()[index]; }
        };
        
        listLocalConstraints.setModel(localConstraintListModel);
        listLocalConstraints.setCellRenderer(new ConstraintCellRenderer());
        
        
        inheritedConstraintListModel = new AbstractListModel() {
            public int getSize() { return myEntity.getInheritedConstraints().length; }
            public Object getElementAt(int index) { return myEntity.getInheritedConstraints()[index]; }
        };
        
        listInheritedConstraints.setModel(inheritedConstraintListModel);
        listInheritedConstraints.setCellRenderer(new ConstraintCellRenderer());
        
        
    }
    
    /**
     * Sets whether the frame shall be editable or not
     * @param editable editable or not
     */
    public void setEditable(boolean editable){
        if(editable == false){
            remove(pnlAddConstraint);
            pnlLocalConstraints.remove(btnDel);
            
        }else{
            add(pnlAddConstraint, 3);
            pnlLocalConstraints.add(btnDel, BorderLayout.EAST);
        }
        repaint();
        validate();
        splitConstraints.setDividerLocation(splitConstraints.getHeight()/2);
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jSeparator2 = new javax.swing.JSeparator();
        pnlHead = new javax.swing.JPanel();
        lblHeader = new javax.swing.JLabel();
        pnlConstraints = new javax.swing.JPanel();
        splitConstraints = new javax.swing.JSplitPane();
        pnlLocalConstraints = new javax.swing.JPanel();
        scrLocalConstraints = new javax.swing.JScrollPane();
        listLocalConstraints = new javax.swing.JList();
        btnDel = new javax.swing.JButton();
        pnlInheritedConstraints = new javax.swing.JPanel();
        scrInheritedConstraints = new javax.swing.JScrollPane();
        listInheritedConstraints = new javax.swing.JList();
        pnlAddConstraint = new javax.swing.JPanel();
        pnlConstraintLine = new jcreek.gui.representation.constraints.pnlConstraintLine();
        pnlButtons = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        btnClear = new javax.swing.JButton();
        btnUpdate = new javax.swing.JButton();
        btnAddConstraint = new javax.swing.JButton();
        pnlCheck = new javax.swing.JPanel();
        btnCheckAll = new javax.swing.JButton();
        btnCheckOne = new javax.swing.JButton();

        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.Y_AXIS));

        setBorder(new javax.swing.border.MatteBorder(null));
        setMinimumSize(new java.awt.Dimension(390, 171));
        setPreferredSize(new java.awt.Dimension(392, 520));
        jSeparator2.setMinimumSize(new java.awt.Dimension(0, 10));
        jSeparator2.setPreferredSize(new java.awt.Dimension(0, 40));
        add(jSeparator2);

        pnlHead.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        lblHeader.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        lblHeader.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        lblHeader.setText("Constraints");
        pnlHead.add(lblHeader);

        add(pnlHead);

        pnlConstraints.setLayout(new java.awt.BorderLayout());

        splitConstraints.setBorder(null);
        splitConstraints.setDividerLocation(80);
        splitConstraints.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        pnlLocalConstraints.setLayout(new java.awt.BorderLayout());

        pnlLocalConstraints.setBorder(new javax.swing.border.TitledBorder("Local constraints"));
        pnlLocalConstraints.setPreferredSize(new java.awt.Dimension(441, 250));
        scrLocalConstraints.setPreferredSize(new java.awt.Dimension(380, 300));
        listLocalConstraints.setMaximumSize(new java.awt.Dimension(1000, 1000));
        listLocalConstraints.setPreferredSize(null);
        listLocalConstraints.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                listLocalConstraintsValueChanged(evt);
            }
        });
        listLocalConstraints.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                listLocalConstraintsMouseClicked(evt);
            }
        });

        scrLocalConstraints.setViewportView(listLocalConstraints);

        pnlLocalConstraints.add(scrLocalConstraints, java.awt.BorderLayout.CENTER);

        btnDel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/jcreek/gui/resources/delete.gif")));
        btnDel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDelActionPerformed(evt);
            }
        });

        pnlLocalConstraints.add(btnDel, java.awt.BorderLayout.EAST);

        splitConstraints.setTopComponent(pnlLocalConstraints);

        pnlInheritedConstraints.setLayout(new java.awt.BorderLayout());

        pnlInheritedConstraints.setBorder(new javax.swing.border.TitledBorder("Inherited constraints"));
        pnlInheritedConstraints.setPreferredSize(new java.awt.Dimension(441, 250));
        scrInheritedConstraints.setToolTipText("Constraits inherited from superclasses");
        scrInheritedConstraints.setPreferredSize(new java.awt.Dimension(380, 200));
        scrInheritedConstraints.setViewportView(listInheritedConstraints);

        pnlInheritedConstraints.add(scrInheritedConstraints, java.awt.BorderLayout.CENTER);

        splitConstraints.setBottomComponent(pnlInheritedConstraints);

        pnlConstraints.add(splitConstraints, java.awt.BorderLayout.CENTER);

        add(pnlConstraints);

        pnlAddConstraint.setLayout(new java.awt.BorderLayout());

        pnlAddConstraint.setBorder(new javax.swing.border.TitledBorder("Add/edit constraint"));
        pnlAddConstraint.setMinimumSize(new java.awt.Dimension(374, 260));
        pnlAddConstraint.setPreferredSize(new java.awt.Dimension(390, 260));
        pnlConstraintLine.setMinimumSize(new java.awt.Dimension(295, 200));
        pnlAddConstraint.add(pnlConstraintLine, java.awt.BorderLayout.CENTER);

        pnlButtons.setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new java.awt.GridLayout(3, 0, 0, 10));

        btnClear.setText("New");
        btnClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnClearActionPerformed(evt);
            }
        });

        jPanel1.add(btnClear);

        btnUpdate.setText("Update");
        btnUpdate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnUpdateActionPerformed(evt);
            }
        });

        jPanel1.add(btnUpdate);

        btnAddConstraint.setText("Add");
        btnAddConstraint.setMaximumSize(new java.awt.Dimension(61, 23));
        btnAddConstraint.setMinimumSize(new java.awt.Dimension(61, 23));
        btnAddConstraint.setPreferredSize(new java.awt.Dimension(61, 23));
        btnAddConstraint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddConstraintActionPerformed(evt);
            }
        });

        jPanel1.add(btnAddConstraint);

        pnlButtons.add(jPanel1, java.awt.BorderLayout.NORTH);

        pnlAddConstraint.add(pnlButtons, java.awt.BorderLayout.EAST);

        add(pnlAddConstraint);

        btnCheckAll.setText("Check all constraints");
        btnCheckAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCheckAllActionPerformed(evt);
            }
        });

        pnlCheck.add(btnCheckAll);

        btnCheckOne.setText("Check constraints on this entity");
        btnCheckOne.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCheckOneActionPerformed(evt);
            }
        });

        pnlCheck.add(btnCheckOne);

        add(pnlCheck);

    }//GEN-END:initComponents

    private void btnCheckOneActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCheckOneActionPerformed
       frmConstraintChecker cc = new frmConstraintChecker();
        cc.show();
        cc.check(myEntity);
    }//GEN-LAST:event_btnCheckOneActionPerformed
    
    private void btnCheckAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCheckAllActionPerformed
        frmConstraintChecker cc = new frmConstraintChecker();
        cc.show();
        cc.check(myEntity.getKnowledgeModel());
    }//GEN-LAST:event_btnCheckAllActionPerformed
    
    private void btnUpdateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnUpdateActionPerformed
        pnlConstraintLine.updateConstraint();
        listLocalConstraints.repaint();
        pnlConstraintLine.clear();
    }//GEN-LAST:event_btnUpdateActionPerformed
    
    private void btnClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnClearActionPerformed
        pnlConstraintLine.clear();
    }//GEN-LAST:event_btnClearActionPerformed
    
    private void listLocalConstraintsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_listLocalConstraintsMouseClicked
        Constraint c = (Constraint)listLocalConstraints.getSelectedValue();
        pnlConstraintLine.setConstraint(c);
    }//GEN-LAST:event_listLocalConstraintsMouseClicked
    
    private void btnDelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDelActionPerformed
        Constraint c = (Constraint)listLocalConstraints.getSelectedValue();
        if(c!=null){
            myEntity.removeConstraint(c);
            repaint();
        }
    }//GEN-LAST:event_btnDelActionPerformed
    
    private void listLocalConstraintsValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_listLocalConstraintsValueChanged
        Constraint c = (Constraint)listLocalConstraints.getSelectedValue();
        pnlConstraintLine.setConstraint(c);
    }//GEN-LAST:event_listLocalConstraintsValueChanged
    
    private void btnAddConstraintActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddConstraintActionPerformed
        Constraint c = pnlConstraintLine.getConstraint();
        
        if(c != null){
            myEntity.addConstraint(c);
            initMyComponents();
            pnlConstraintLine.clear();
        }
        
    }//GEN-LAST:event_btnAddConstraintActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddConstraint;
    private javax.swing.JButton btnCheckAll;
    private javax.swing.JButton btnCheckOne;
    private javax.swing.JButton btnClear;
    private javax.swing.JButton btnDel;
    private javax.swing.JButton btnUpdate;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JLabel lblHeader;
    private javax.swing.JList listInheritedConstraints;
    private javax.swing.JList listLocalConstraints;
    private javax.swing.JPanel pnlAddConstraint;
    private javax.swing.JPanel pnlButtons;
    private javax.swing.JPanel pnlCheck;
    private jcreek.gui.representation.constraints.pnlConstraintLine pnlConstraintLine;
    private javax.swing.JPanel pnlConstraints;
    private javax.swing.JPanel pnlHead;
    private javax.swing.JPanel pnlInheritedConstraints;
    private javax.swing.JPanel pnlLocalConstraints;
    private javax.swing.JScrollPane scrInheritedConstraints;
    private javax.swing.JScrollPane scrLocalConstraints;
    private javax.swing.JSplitPane splitConstraints;
    // End of variables declaration//GEN-END:variables
    
    /**
     * Cell renderer for the constraint list
     */
    class ConstraintCellRenderer extends DefaultListCellRenderer {
        
        public java.awt.Component getListCellRendererComponent(
        JList list,
        Object value,   // value to display
        int index,      // cell index
        boolean iss,    // is the cell selected
        boolean chf)    // the list and the cell have the focus
        {
            Constraint c = (Constraint)value;
            super.getListCellRendererComponent(list, value, index, iss, chf);
            if(c != null){
                super.setText(c.toString());//
                super.setToolTipText("<html>" + c.toString() + "<p>" + c.getDescription() + "<html>");
            }else
                super.setText("");
            
            return this;
        }
    }
}
