/*
 * pnlGeneralConstraint.java
 *
 * Created on 13. februar 2006, 13:05
 */

package jcreek.gui.representation.constraints;

import javax.swing.JFrame;
import java.awt.BorderLayout;
import jcreek.representation.Entity;

/**
 *
 * @author  Martin Stige
 *
 * Form for showing and editing general constraints. Contains a JTextArea for
 * writing constraints and a button for launching a larger editor.
 */
public class pnlGeneralConstraint extends javax.swing.JPanel {
    Entity myEntity; 
    /** the entity holding the constriant. This is not used
     * directly. It is passed to the pnlGeneralConstraintLarge
     * as a means to get access to the knowledge model for testing
     */
    
    /** Creates new form pnlGeneralConstraint */
    public pnlGeneralConstraint() {
        initComponents();
    }
    
    /** 
     * Setting the entity refference
     * @param entity the entity
     */
    public void setEntity(Entity entity){
        myEntity = entity;
    }
    
    /** Clears the editor */
    public void clear(){
        txtText.setText(
        "/* Describe the constraint here */ \n" +
        "/* use entity to reffer to the entity.*/ \n" +
        "/* entity.getKnowledgeModel() to get knowledgemodel*/ \n\n" +
        "ConstraintCheckResult check(Entity entity){ \n\n" +
        "\treturn new ConstraintCheckResult(false, \"bla bla bla\"); \n" +
        "}"
        );
    }
    
    /**
     * Setting the source code defining the constraint
     * @param text the source code
     */
    public void setConstraintString(String text){ txtText.setText(text); }
    
    /** Returns the source code string */
    public String getConstraintString(){ return txtText.getText(); }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        scrText = new javax.swing.JScrollPane();
        txtText = new javax.swing.JTextArea();
        btnWindowToggle = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        txtText.setFont(new java.awt.Font("Courier New", 0, 10));
        txtText.setTabSize(3);
        txtText.setText("/* use entity to reffer to the entity.  */\n/* entity.getKnowledgeModel() to get knowledgemodel      */\n\nConstraintCheckResult check(Entity entity){\n\n    return new ConstraintCheckResult(false, \"bla bla bla\");\n}\n\n");
        txtText.setPreferredSize(new java.awt.Dimension(600, 600));
        scrText.setViewportView(txtText);

        add(scrText, java.awt.BorderLayout.CENTER);

        btnWindowToggle.setText("Large window");
        btnWindowToggle.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnWindowToggleActionPerformed(evt);
            }
        });

        add(btnWindowToggle, java.awt.BorderLayout.SOUTH);

    }//GEN-END:initComponents
    
    private void btnWindowToggleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnWindowToggleActionPerformed
        JFrame frame = new JFrame("Write general constraint");
        frame.getContentPane().setLayout(new BorderLayout());
        
        pnlGeneralConstraintLarge panel = new pnlGeneralConstraintLarge(this, txtText.getText(), myEntity);
        frame.getContentPane().add(panel, BorderLayout.CENTER);
        frame.setSize(500,500);
        frame.show();
        
    }//GEN-LAST:event_btnWindowToggleActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnWindowToggle;
    private javax.swing.JScrollPane scrText;
    private javax.swing.JTextArea txtText;
    // End of variables declaration//GEN-END:variables
    
}
