/*
 * pnlGeneralConstraint.java
 *
 * Created on 13. februar 2006, 13:05
 */

package jcreek.gui.representation.constraints;

import javax.swing.JFrame;
import java.awt.BorderLayout;
import jcreek.representation.Entity;
import jcreek.representation.constraints.DJavaAdapter;
/**
 *
 * @author  Martin Stige
 *
 * EditorFrame for editing general constraints
 */
public class pnlGeneralConstraintLarge extends javax.swing.JPanel {
    pnlGeneralConstraint mother;
    Entity myEntity;
    
    /**
     * Creates new form pnlGeneralConstraint
     * @param mother the constraint panel that launches this window. This
     * is done to avoid writing complex change listener classes
     * @param constraintString the text to be displayed in the editor
     * @param entity the entity being constraind. It is passed by to allow
     * a simple way to test the constraints
     */
    public pnlGeneralConstraintLarge(pnlGeneralConstraint mother, String constraintString, Entity entity) {
        initComponents();
        this.mother = mother;
        txtText.setText(constraintString);
        myEntity = entity;
    }
    
    /** 
     * Sets the constraint string to be displayed in the editor
     * @param text the constraint string
     */
    public void setConstraintString(String text){ txtText.setText(text); }
    
    /** Returns the text in the editor */     
    public String getConstraintString(){ return txtText.getText(); }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        splitEditor = new javax.swing.JSplitPane();
        scrText = new javax.swing.JScrollPane();
        txtText = new javax.swing.JTextArea();
        scrOut = new javax.swing.JScrollPane();
        txtOut = new javax.swing.JTextArea();
        pnlButtons = new javax.swing.JPanel();
        btnTest = new javax.swing.JButton();
        btnClearOutput = new javax.swing.JButton();

        setLayout(new java.awt.BorderLayout());

        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });

        splitEditor.setDividerLocation(200);
        splitEditor.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        splitEditor.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                splitEditorComponentShown(evt);
            }
        });

        txtText.setFont(new java.awt.Font("Courier New", 0, 12));
        txtText.setTabSize(3);
        txtText.setPreferredSize(new java.awt.Dimension(1000, 1500));
        txtText.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                txtTextMouseMoved(evt);
            }
        });
        txtText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                txtTextKeyTyped(evt);
            }
        });

        scrText.setViewportView(txtText);

        splitEditor.setLeftComponent(scrText);

        txtOut.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        txtOut.setEditable(false);
        txtOut.setFont(new java.awt.Font("Courier New", 0, 12));
        txtOut.setPreferredSize(new java.awt.Dimension(300, 1500));
        scrOut.setViewportView(txtOut);

        splitEditor.setRightComponent(scrOut);

        add(splitEditor, java.awt.BorderLayout.CENTER);

        pnlButtons.setLayout(new java.awt.BorderLayout());

        btnTest.setText("Check syntax");
        btnTest.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnTestActionPerformed(evt);
            }
        });

        pnlButtons.add(btnTest, java.awt.BorderLayout.CENTER);

        btnClearOutput.setText("Clear output");
        btnClearOutput.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnClearOutputActionPerformed(evt);
            }
        });

        pnlButtons.add(btnClearOutput, java.awt.BorderLayout.EAST);

        add(pnlButtons, java.awt.BorderLayout.SOUTH);

    }//GEN-END:initComponents
    
    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        splitEditor.setDividerLocation((int)(splitEditor.getHeight()*0.8));
    }//GEN-LAST:event_formComponentResized
    
    private void splitEditorComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_splitEditorComponentShown
        
    }//GEN-LAST:event_splitEditorComponentShown
    
    private void btnClearOutputActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnClearOutputActionPerformed
        txtOut.setText("");
    }//GEN-LAST:event_btnClearOutputActionPerformed
    
    private void btnTestActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnTestActionPerformed
        txtOut.setText("Checking syntax...");
        DJavaAdapter adapter = new DJavaAdapter(myEntity);
        String checkResult = adapter.checkSyntax(txtText.getText());
        txtOut.setText(checkResult);
    }//GEN-LAST:event_btnTestActionPerformed
    
    private void txtTextMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_txtTextMouseMoved
        mother.setConstraintString(txtText.getText());
    }//GEN-LAST:event_txtTextMouseMoved
    
    private void txtTextKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtTextKeyTyped
        mother.setConstraintString(txtText.getText());
    }//GEN-LAST:event_txtTextKeyTyped
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnClearOutput;
    private javax.swing.JButton btnTest;
    private javax.swing.JPanel pnlButtons;
    private javax.swing.JScrollPane scrOut;
    private javax.swing.JScrollPane scrText;
    private javax.swing.JSplitPane splitEditor;
    private javax.swing.JTextArea txtOut;
    private javax.swing.JTextArea txtText;
    // End of variables declaration//GEN-END:variables
    
}
