/*
 * pnlCardinalityConstraint.java
 *
 * Created on 13. januar 2006, 14:33
 */

package jcreek.gui.representation.constraints;

/**
 *
 * @author  Martin Stige
 */
public class pnlValueRangeConstraint extends javax.swing.JPanel {
    
    /** Creates new form pnlCardinalityConstraint */
    public pnlValueRangeConstraint() {
        initComponents();
    }
    
    public Number getMin(){
        try{
            return new Double(txtMin.getText().trim());
        }catch(NumberFormatException e){
            return null;
        }
    }
    
    public Number getMax(){
        try{
            return new Double(txtMax.getText().trim());
        }catch(NumberFormatException e){
            return null;
        }
    }
    
    public boolean getAllowed() { return rdbAllowed.isSelected(); }
    
    public void setMax(Number m){
        if(m == null)
            txtMax.setText("");
        else
            txtMax.setText(m+"");
    }
    
    public void setMin(Number m){
        if(m == null)
            txtMin.setText("");
        else
            txtMin.setText(m+"");
    }
    
    public void setAllowed(boolean a) {
        if(a)
            rdbAllowed.setSelected(true);
        else
            rdbDisallowed.setSelected(true);
    }
    
    public void clear(){
        txtMax.setText("<max>");
        txtMin.setText("<min>");
        rdbAllowed.setSelected(true);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        groupAllowed = new javax.swing.ButtonGroup();
        txtMin = new javax.swing.JTextField();
        txtMax = new javax.swing.JTextField();
        rdbAllowed = new javax.swing.JRadioButton();
        rdbDisallowed = new javax.swing.JRadioButton();

        setLayout(new java.awt.GridLayout(2, 0, 10, 0));

        txtMin.setColumns(4);
        txtMin.setText("<min>");
        txtMin.setMinimumSize(new java.awt.Dimension(43, 20));
        txtMin.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtMinFocusGained(evt);
            }
        });

        add(txtMin);

        txtMax.setColumns(4);
        txtMax.setText("<max>");
        txtMax.setMinimumSize(new java.awt.Dimension(43, 20));
        txtMax.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                txtMaxFocusGained(evt);
            }
        });

        add(txtMax);

        rdbAllowed.setSelected(true);
        rdbAllowed.setText("Range allowed");
        groupAllowed.add(rdbAllowed);
        add(rdbAllowed);

        rdbDisallowed.setText("Range disallowed");
        groupAllowed.add(rdbDisallowed);
        add(rdbDisallowed);

    }//GEN-END:initComponents
    
    private void txtMaxFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtMaxFocusGained
        txtMax.setSelectionStart(0);
        txtMax.setSelectionEnd(txtMax.getText().length());
    }//GEN-LAST:event_txtMaxFocusGained
    
    private void txtMinFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_txtMinFocusGained
        txtMin.setSelectionStart(0);
        txtMin.setSelectionEnd(txtMin.getText().length());
        
    }//GEN-LAST:event_txtMinFocusGained
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup groupAllowed;
    private javax.swing.JRadioButton rdbAllowed;
    private javax.swing.JRadioButton rdbDisallowed;
    private javax.swing.JTextField txtMax;
    private javax.swing.JTextField txtMin;
    // End of variables declaration//GEN-END:variables
    
}
