/*
 * GeneralConstraint.java
 *
 * Created on 13. februar 2006, 12:52
 */

package jcreek.representation.constraints;

import jcreek.representation.*;
import jcreek.representation.constraints.*;
/**
 * General constraint.<br>
 * Provides the ability to write arbitrary complex constraints using Java code.
 *
 * @author  Martin Stige
 */
public class GeneralConstraint extends Constraint{
    
    /** Creates a new instance of GeneralConstraint
     *
     * @param knowledgeModel the knowledge model
     * @param constraintString the source code describing the constraint
     * @param description description of the constraint
     */
    public GeneralConstraint(KnowledgeModel knowledgeModel, String constraintString, String description) {
        super(knowledgeModel, description);
        constraintData.setConstraintObject( new GeneralConstraintObject(constraintString) );
    }
    
    /**
     * Creates a new instance of CardinalityConstraint from a constraint data object
     * @param km the knowledge model
     * @param data the constraint data to be contained in the constraint
     */
    public GeneralConstraint(KnowledgeModel km, ConstraintData data){
        super(km, data);
    }
    
    /**
     * Sets the constraint string, the source code
     * @param constraintString the string containing the source code
     */
    public void setConstraintString(String constraintString){
        GeneralConstraintObject o = (GeneralConstraintObject) constraintData.getConstraintObject();
        o.setConstraintString(constraintString);
    }
    
    /** Returns the constraint string, source code */
    public String getConstraintString(){
        GeneralConstraintObject o = (GeneralConstraintObject) constraintData.getConstraintObject();
        return o.getConstraintString();
    }
}
